#define NUMBER_OF_RADIO_BLOCKS 1

// --------------------------------------------------------------
//
// Radio Variables


#IF compile_com_message 1 ;
#IFNOT RadioFunctionsVersion 2 ;
char MessageBlockId[number_of_devices][9];
int  MessageTransmitBlockNumber[number_of_devices];
int  MessageTemporaryBlockNumber[number_of_devices];
int  MessageReceiveBlockNumber[number_of_devices];
int  MessageReceiveSequencialNumber[number_of_devices];
int reset_function;
#ELSE ;
int MessageNumberSendmessage;
#ENDIF ;
int LedColor;
public char destination_id[9];
#ENDIF ;

#IF compile_radio_message 1 ;
#IFNOT compile_com_message 1 ;
#IFNOT RadioFunctionsVersion 2 ;
char MessageBlockId[number_of_devices][9];
int  MessageTransmitBlockNumber[number_of_devices];
int  MessageTemporaryBlockNumber[number_of_devices];
int  MessageReceiveBlockNumber[number_of_devices];
int  MessageReceiveSequencialNumber[number_of_devices];
int reset_function;
#ELSE ;
int MessageNumberSendmessage;
#ENDIF ;
int LedColor;
public char destination_id[9];
#ENDIF ;
#ENDIF ;



#define	Message_ANSWER						65535
// #define 	Message_PROGRAM						65534
// #define	Message_NEWANSWER						65534
#define	Message_ANSWER_HARD_RESET				65534
#define	Message_ANSWER_START_READING_CONF		65533
#define	Message_ANSWER_RESET					65532
#define	Message_ANSWER_INVALID_ID					65531

#define	Message_NORMAL_BLOCK					65530			// < 65530
#define 	Message_RESET							0

// --------------------------------------------------------------

#IFNOT software_type RADIOBASE ;

auto_configure_terminal(char *st)
{
	char aux[10];
	int ct;
	int ini;
	int ct_aux;
	
	
	ct=-1;
	do
	{
		ini=ct+1;		

#IF tag_type Rfid125 ;
	if(!memcmp(st+ini,"CR=",3))
	{
		configure_Rfid125(st+ini+4);
	}
#ENDIF ;

#IF laser_type psc ;
		
		if(hardware_is_laser_intermec)
		{
			if(!memcmp(st+ini,"LI=",3))
			{
				configure_laser_intermec(st+ini+4);
			}
		}
		else
		{					
			if(!memcmp(st+ini,"LC=",3))
			{
				configure_laser(st+ini+4);
			}
		}
#ENDIF ;			
		if(!memcmp(st+ini,"LC=",3) || !memcmp(st+ini,"LI=",3))
		{
			ct=*(st+ini+3)+4+ct;
		}

		if(!memcmp(st+ini,"RC=",3))				// Radio Configure
		{
										// Quim tens aqui uma string terminada com 0, podes ter varias vezes esta configuraao...
		}

		if(!memcmp(st+ini,"RT=",3))				// Radio Timeout
		{
										// Quim tens aqui uma string terminada com 0, podes ter varias vezes esta configuraao...
		}
		
		if(!memcmp(st+ini,"ID=",3))
		{
			set_terminal_id(st+ini+3);	
		}
		if(!memcmp(st+ini,"FB=",3))
		{
			AutoFindBase=atoi(st+ini+3);
		}
		if(!memcmp(st+ini,"NB=",3))
		{
			NumberOfBases=atoi(st+ini+3);
		}
		if(!memcmp(st+ini,"PD=",3))
		{
			power_off_countdown_seconds=atoi(st+ini+3);
		}
		if(!memcmp(st+ini,"RT=",3))
		{
			time_to_reset=atoi(st+ini+3);
		}
		if(!memcmp(st+ini,"PW=",3))
		{
			do
			{
				cls();
				*aux=0;
				print_string("PASSWORD:");
				text(aux,9,0);
			}while(strcmp(aux,st+ini+3));
		}
#IF compile_os_menu 1 ;
		if(!memcmp(st+ini,"ST=",3))
		{
			ini+=3;
			cls();
			print_string("Select ID");
			new_line();
			while(*(st+ini)!=0)
			{
				say(st+ini);						// TerminalID
				ini+=strlen(st+ini)+1;
				new_line();
				print_string(st+ini);					// Text
				ini+=strlen(st+ini)+1;
				get(check_exit,st+ini,0,0);				// Configurations	'ID=xxxx0PW=xxxxxxx0'0
								
				while(*(st+ini)!=0)					// Avanca para fim das configuraoes desse terminal
				{
					ini+=strlen(st+ini)+1;	
				}
				ini++;
				new_line();
			}
			read();		
			
			ct=ini;
			ct_aux=ct;
			auto_configure_terminal(a_func_check_exit);
			ct=ct_aux;
		}		
#ENDIF ;
											// Posiciona-se no proximo 0
		do
		{
			ct++;
		}while(st[ct]!=0);
		
	}while(*(st+ct+1)!=0);
	save_configuration_data();
	return(ct);
}

#ENDIF ;


// --------------------------------------------------------------



debug_info(char *txt,int n)
{
	int ct_loop;
	ct_loop++;
	new_line();
	print_string(txt);print_string(":");
	print_number(n);print_string(":");
	print_number(ct_loop);
	really_update_screen();
	beep(900,900);
}

// --------------------------------------------------------------


#IF wireless_network 1 ;

#include "sys61.c"
int radio_busy()
{
#IFGREATEROREQUAL system_version 700 ;
	if(radio_receiver_status(1000,250)<=2)
	{
		return(0);
	}
#ELSE ;
	delay(1000);
	if( read_cpu_register(CPU_PORTC ) & 2 )
	{
		return(0);
	}
#ENDIF ;	

	return(1);
}

#IF compile_radio_message 1 ;

wait_radio_free()
{
	int timeout;
	radio_channel_receive
	timeout=0;
	while( radio_busy() && timeout<75)
	{
		timeout++;
		delay(rnd(50000));
	}
	radio_channel_off
}

read_destination_id()
{
	*(destination_id)=read_cpu_register(CPU_RADIO_SYNCED1);
	*(destination_id+1)=read_cpu_register(CPU_RADIO_SYNCED1+1);
	*(destination_id+2)=read_cpu_register(CPU_RADIO_SYNCED1+2);
	*(destination_id+3)=read_cpu_register(CPU_RADIO_SYNCED1+3);
	*(destination_id+4)=read_cpu_register(CPU_RADIO_SYNCED1+4);
	*(destination_id+5)=read_cpu_register(CPU_RADIO_SYNCED1+5);
	*(destination_id+6)=read_cpu_register(CPU_RADIO_SYNCED1+6);
	*(destination_id+7)=read_cpu_register(CPU_RADIO_SYNCED1+7);
}

#include "sys70.c"
#include "sys63.c"
#ENDIF ;
#ENDIF ;


// --------------------------------------------------------------


#IF compile_com_message 1 ;

char com2_header[10]={0,0,0,0,0,0,255,255,45,62};

#IF radio_type gprs ;
#include "gprs_tcpip.c"
#include "sys65.c"
#include "sys70.c"
#define	reset_message			reset_gprs_message

#ELSE
#include "sys62.c"
#include "sys70.c"

#ENDIF;


#IF software_type RADIOBASE ponto;

base_configuration_command(char ch)
{
	int reset_status,b,channel,a;
	int headerct;
	headerct=0;

	if(ch=='X') 
	{ 
		headerct=1;
	}
		
	char header[20]="X1YWAZ -->-<";
	if(reset_status==2)
	{
		reset_status=0;
	}

	write_cpu_register32(CPU_COM_TIMEOUT,50000);
	do
	{
		a=read_com2_byte();
		if(a!=header[headerct])
		{			
			beep(10,10);
			return(0);
		}
		headerct++;	
	}while(headerct<strlen(header));

	write_cpu_register32(CPU_CHECKSUM,0);

	a=read_com2_byte();	
	if( a =='<' )				// RESET POR SOFTWARE
	{
		reset(2);
	}

	if( a=='*')
	{
		reset_status=2;
		write_com2_byte('K');
		delay(100000);
		if(!strcmp(terminal_id,"ttt00"))
		{
			base_production_test();
		}
		reset(0);
	}

	if(a=='S')
	{
		read_com2_bytes(&base_send_to_serial_or_radio,1);
		save_configuration_data();
		if(!reset_status)
		{
			reset(0);
		}
	}

#IFNOT software_type ponto;

	if( a=='G')
	{
		write_com2_block("--><",4);
		write_com2_block("3.0",3);
		write_com2_block(terminal_id,5);
		write_com2_block(work_base_id,5);
		itoa(value_func_set_radio_khz,temp_string,10);
		write_com2_block(temp_string,5);
		write_com2_block(os_baud_rates[index_func_choose_baud_rate],6);
		write_com2_block(&base_send_to_serial_or_radio,1);
		reset_status=1;
	}

	if( a == 'I' )								// Set ID
	{
		read_com2_bytes(terminal_id,9);
		read_com2_bytes(work_base_id,9);
		set_terminal_id(terminal_id);
		save_configuration_data();
		if(!reset_status)
		{
			reset(0);
		}
	}

	if( a == 'B' )								// Set BaudRate
	{
		read_com2_bytes(&b,4);
		set_baud_rate(b);
		save_configuration_data();
		if(!reset_status)
		{
			reset(0);
		}
	}

	if( a == 'L' )								// Change Led
	{
		b=read_com2_byte();
		LedColor=b;	
	}


	if( a == 'R' )								// Set Radio
	{
		read_com2_bytes(&b,1);					// Radio Module - LIXO
		read_com2_bytes(&b,4);					// Khz
		set_radio_khz(b);
		read_com2_bytes(&channel,4);				// Channel
		save_configuration_data();
		if(!reset_status)
		{
			reset(0);
		}
	}
	
#ENDIF ;
}

#ENDIF ;


#IF compile_debug_wait_com2_block 1 ;

	int debug_number_wait_com2_block;
	int debug_wait_com2_block_timeout;
	int debug_wait_com2_block_timeout2;

#ENDIF;


#IF software_type RADIOBASE BATCH ;
#IF RadioFunctionsVersion	 2
write_com2_full_block(char *BlockPtr,int MessageSize, char *destination_id,char *local_id )
{
	int Aux2;
	MessageSize+=8;
	message_channel_send
	write_message_header
	write_message_block_cc(destination_id,8	wmb_sufix
	write_message_block(&MessageSize,1		wmb_sufix
	write_message_block(local_id,8			wmb_sufix
	write_message_block(BlockPtr,MessageSize-8 	wmb_sufix
	write_message_checksum
	message_channel_delay_after_send
	message_channel_off
}
#ENDIF;


wait_com2_block(int timeout)
{
	char	buffer[256];
	int	ptr;	
	int	a;
	int	size_of_message;
	int	sync_read_size;
	int	checksum,error;

	ptr=0;
	error=0;
	write_cpu_register32(CPU_COM_TIMEOUT,timeout);
	do
	{
		a=read_com2_byte();
		if( a == -1 )
		{
#IF radio_type gprs ;
			write_cpu_register(4011,256*(255-16));					// Para desencravar a serie...		
			write_cpu_register(4011,256*255+16);
#ENDIF ;
			error+=1000;
			break;
		}


#IF software_type RADIOBASE BATCH;
		if( a != '-' )					// Detect device
		{
#IF software_type RADIOBASE;
			if(a=='+')
			{
				write_cpu_register(CPU_PORTB_VALUE,48896);			// BUG PIC 3.04 -- 3.06
				write_com2_byte('-');
			}
#ENDIF;
			error=1;
			continue;
		}
		a=read_com2_byte();	
#ENDIF ;
		write_cpu_register32(CPU_COM_TIMEOUT,25000);
		if( a != '>' )
		{
#IF software_type RADIOBASE ;
			if( a == '<' )
			{	
				base_configuration_command(0);
				write_cpu_register32(CPU_COM_TIMEOUT,timeout);
				error=2;
				continue;
			}
#ENDIF ;
			write_cpu_register32(CPU_COM_TIMEOUT,timeout);
			error=3;
			continue;
		}


		write_cpu_register32(CPU_CHECKSUM,0);

		if( read_com2_bytes(destination_id,8) == -1 )
		{
			error=4;
			break;
		}

#IFNOT software_type RADIOBASE ;

		if(memcmp(destination_id,terminal_id,sync_read_size))
		{
			if(memcmp(destination_id,"CONFIG",6))
			{
				write_cpu_register32(CPU_COM_TIMEOUT,timeout);
				error=5;
				continue;
			}
		}	
#ENDIF ;
		if( read_com2_bytes(&size_of_message,1) == -1 )
		{
			error=6;
			break;
		}

		if( read_com2_bytes(buffer,size_of_message) == -1 )
		{
			error=7;
			break;
		}

		checksum=read_cpu_register32(CPU_CHECKSUM);
		if( read_com2_bytes(&a,4) == -1 )
		{
			error=8;
			break;
		}

		if(a==checksum)
		{
			if(memcmp(buffer,"CONFIGUR",8))
			{	
				return(size_of_message);
			}
#IF software_type RADIOBASE BATCH;
			else
			{
				beep(30,30);
				push_variable(timeout);
				base_configuration(buffer+8);
				timeout=pop_variable();
			}
#ENDIF ;
		}
		else
		{
			error=9;	
		}
		write_cpu_register32(CPU_COM_TIMEOUT,timeout);
	}while(1);
	return(0);
}

read_com2_block(char *buffer,int n)
{
	memcpy(buffer,buffer_func_wait_com2_block+ptr_func_wait_com2_block,n);
	ptr_func_wait_com2_block+=n;
}

base_configuration(char *buffer)
{
	int *aux;
	int baud;
	int old_baud_rate;
	int size;

	if(!memcmp(buffer,"SBAU",4))
	{
		aux=buffer+4;
		set_baud_rate2(*aux);		
		cursor(0);
		print_string("Connected...");print_number(*aux);		
	}

	if(!memcmp(buffer,"TBAU",4))
	{
		if(*aux==19200)
		{
			
			cursor_width(0);
			screen_format=0;
			set_display(0);
			cls();
		}			
		old_baud_rate=baud_func_set_baud_rate2;
		aux=buffer+4;
		baud=*aux;
		cursor(0);
		print_string("Trying......");print_number(*aux);
		set_baud_rate2(baud);		
		size=wait_com2_block(250000);
		if(size)
		{
			cursor(0);
			print_string("Answer......");print_number(baud);	
			memcpy(buffer,"TBAU",4);
			memcpy(buffer+4,&baud,4);
			read_com2_block(buffer+8,size);
			write_com2_full_block(buffer,size+8,"CONFIGUR",terminal_id);
		}
		cursor(0);
		print_string("Connected...");print_number(old_baud_rate);		
		set_baud_rate2(old_baud_rate);		
	}

	if(!memcmp(buffer,"BEEP",4))
	{
		beep(200,200);
	}

	if(!memcmp(buffer,"RSET",4))
	{
		if(offline_function_to_test_if_it_is_empty)
		{
			if(offline_function_to_test_if_it_is_empty())
			{
				reset(3+'7'*256);	
			}
			else
			{
				 #IF software_type  BATCH;
					disconnect_connection("Terminal not empty!");
				#ELSE;
					error("Terminal not empty!");
				#ENDIF;
			}
		}
		else
		{
			reset(3+'7'*256);	
		}
	}
	
	if(!memcmp(buffer,"CHKS",4))
	{
		memcpy(buffer+4,&program_checksum,4);
		write_com2_full_block(buffer,8,"CONFIGUR",terminal_id);
	}

	if(!memcmp(buffer,"PICV",4))
	{
		itoa(value_func_pic_version,buffer+4,10);
		write_com2_full_block(buffer,8,"CONFIGUR",terminal_id);
	}

	if(!memcmp(buffer,"VERS",4))
	{
		memcpy(buffer+4,CONFIG_VERSION,4);
		write_com2_full_block(buffer,8,"CONFIGUR",terminal_id);
	}

}
#ENDIF ;




#ENDIF ;
